const

TrueF = $FFFF;
FalseF = $0000;

WriteFlag : word = $8000;
BusyMask : word = $8000;
DAVMask : word = $4000;
IRQSetMask : word = $2000;
GoMask : word = $1000;
Sysclk = 50E6;
A24Signature = $CAFE;
A24DefaultPort = $0220;

FIFOPortOffset = 0;
CommandPortOffset = 2;
DataPortOffset = 4;
SignaturePortOffset = 6;
ResetPortOffset = $0E;


onekhztimer		= $0C350;
codeversion		= $0B2;
cardmodeauto		= 0;
cardmode5b		= 1;
cardmode2d5b		= 2;
cardmode5u		= 3;
cardmode2d5u		= 4;

adoffset5b		= 22;
adgain5b		= 23;
adoffset2d5b		= 24;
adgain2d5b		= 25;
adoffset5u		= 26;
adgain5u		= 27;
adoffset2d5u		= 28;
adgain2d5u		= 29;
adoffset		= 30;
adgain			= 32;
rawaddata		= 33;
caldata                 = 35;
adsign			= 37;
boundedfifocnt		= 38;
irqsetthresh		= 39;
irqclrthresh		= 40;
datatag			= 41;
avemask			= 42;
mtdraw_calloc		= 43;
mtdautozeroloc		= 44;
cardmode		= 45;
detectread		= 46;
cardmode5udet		= 47;
cardmode2d5bdet		= 48;
SingleEnd		= 49;
Temp                    = 50;

{ eeprom routine frame offsets }
eedata			= 0;	{ data to/from routine }
eeadd			= 1;	{ eeprom address }
eecom			= 2;    { read or write command }
eemask			= 3;	{ temp }
eetemp			= 4;	{ temp }
eereturn		= 5;	{ temp }

EEADOffset5b		= 1;
EEADGain5b		= 2;
EEADOffset2d5b		= 3;
EEADGain2d5b		= 4;

EEADOffset5u		= 5;
EEADGain5u		= 6;
EEADOffset2d5u		= 7;
EEADGain2d5u		= 8;

EECardMode		= 9; { card mode, if 0  then autodetect}


{ test and maintenance stuff }

DoEEPROMFlag		= 80;
EEPROMDataIn	        = 81;
EEPROMDataOut	        = 82;
EEPROMAdd		= 83;
EEPROMCom		= 84;
EEPROMFrame		= 90;

dotestramflag		= 100;


{ internal i/o port locations }
commandreg               =      $400;
{  command reg bits }
crparmmaskhigh           =      $7;
crparmmasklow            =      $FF;
crwritemaskhigh          =      $80;
crwritemasklow           =      $0;
clearbusyflag            =      $401;
datareglow               =      $402;
datareghigh              =      $403;
statusreg                =      $405;
{  statusreg bits: }
srdavflag                =      $1;
srhostbusyflag           =      $2;
srhostfifofull           =      $4;
srhostfifoemty           =      $8;
multa                    =      $406;
multb                    =      $407;
prodlow                  =      $408;
prodhigh                 =      $409;
addata                   =      $40A;
adclrdav                 =      $40A;
hostfifopush             =      $410;
hostfifopop              =      $411;
hostfifoclr              =      $412;
hostfifocntlow           =      $412;
hostfifocnthigh          =      $413;

IRQDriveReg              =      $414;

{ IRQDriveReg bits: }

IDTSEnable               =      $10;
IDMask                   =      $40;

setirq                   =      $415;
clrirq                   =      $416;
portadata                =      $418;
portaddr                 =      $419;
portbdata                =      $41A;
portbddr                 =      $41B;

MuxTableWAdd             =      $420;
MuxTableData             =      $421;

{  mux table data bits (in msb) }
MTDave0                  =      $1;
MTDave1                  =      $2;
MTDave2                  =      $4;
MTDinMode0               =      $8;
MTDinMode1               =      $10;
MTDAutoZero              =      $20;
MTDraw_cal               =      $40;
MTDPtrClr                =      $80;

InmodeNormal             =      $00;
InModeReverse            =      MTDInMode0;
InModeRef                =      MTDInMode1;
InModeGnd                =      MTDInMode0 or MTDInMode1;

MuxTableptr              =      $422;
MuxTabledest             =      $423;

ConvStartReg             =      $424;
{ convstartreg bits: }
CStimerStart             =      $1;             { rw - ena for timer start conv }
CSProcStart              =      $2;             { rw - ena for internal proc start conv }
CSExtStart               =      $4;             { rw - ena for external start conv }
CSExtStartPol            =      $8;             { rw - polarity of external start conv }
CSHostStart              =      $10;            { rw - ena for host start conversion }
CSTimerFre               =      $20;            { rw - enable timer clock free run }
CSProcStartBurst         =      $40;            { rw - enables proc write to start burst (set go) }
CSExtStartBurst          =      $80;            { rw - enable external SC pin to start burst }
CSExtStartBurstPol       =      $100;           { rw - external SC burst start polarity }
CSHostStartBurst         =      $200;           { rw - enable host writes to start burst }
CSGoStatus               =      $8000;          { ro - can read go status here }

BurstCountLow            =      $425;           { low word of burst count register }
BurstCountHigh           =      $426;           { high word of burst count register }

ClearGo                  =      $427;           { writes here cleare go }

ProcStartConv            =      $428;   { internal writes here start a conversion }
{  A-D mode register }
ModeReg                  =      $429;
{  modereg bits: }
MRPowerdown              =      $1;
MRADReset                =      $2;
MRImpulse                =      $4;
MRWarp                   =      $8;
MROB_2C                  =      $10;
MREnaPwr                 =      $20;
MRDC                     =      $40;

TimerLow                 =      $42A;           { ; low 16 bits or 24 bit prog divider }
TimerHigh                =      $42B;           { ; high 8 bits (writes here do 24 bit update) }

eereadcom                =      $6;
eewritecom               =      $5;
eemisccom                =      $4;
led                      =      $440;
hardwarerev		 =      $441;
