{ 4A24 DEMO SOFTWARE - POLLED MODE 4A24 READ AND PRINT ROUTINE }


{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}

{$DEFINE MAIN}                                 { to allow 4A24 low compile by itself }
uses dos,crt;
{$I 4A24LOW }                 { include low level 4A24 I/O }
{ program polled 4A24 }
const
AverageTimes = 1000;

var
Channel :  byte;
ADCData,RawData : longint;
RawMax,RawMin : longint;
Count : word;
TheCardMode : word;
RealData,RealPP : real;
Scale : real;
Signed : boolean;
SingleFlag: boolean;
Sstring,Istring : string;
InMode,InputMode,Maxchannel,MaxMode : byte;
procedure CheckFor4A24;
begin
  if not CardThere4A24 then
  begin
    writeln('Could not find 4A24... aborting program');
    halt(2);
  end; { if }
end; { Check for 4A24 }

begin  { main }
  SetupPorts(A24DefaultPort);
  CheckFor4A24;
  ResetDSP; { in case user changed jumpers }
  delay(500);
  SetupForPolledMode(0,0);
  TheCardMode := ReadParamWord(cardmode);
  Signed := true;
  case TheCardMode of
    CardMode5b : Scale := 5/32767;
    CardMode2d5b : Scale := 2.5/32767;
    CardMode5u :
    begin
      Scale := 5/65535;
      Signed := false;
    end;
  end; { case }
  if signed then Sstring := 'signed data' else Sstring := 'unsigned data';
  if ReadParamWord(SingleEnd) <> 0 then SingleFlag := true else SingleFlag := false;
  ClrScr;
  writeln('4A24 polled mode: ',ModeString(TheCardMode,ReadParamWord(SingleEnd)),' ',(Sstring));
  MaxChannel := 7;
  MaxMode := 2;
  if SingleFlag then
  begin
    MaxChannel := 15;
    MaxMode := 1;
  end;
  while not(KeyPressed) do
  begin
    writeln;
    GotoXY(1,3);
    for InMode := 1 to MaxMode do
    begin
      if InMode = 1 then InputMode := 0 else InputMode := InModeReverse;
      for  Channel := 0 to MaxChannel do
      begin
        RawMin := 100000;
        RawMax := -100000;
        PolledModeSetChannel(channel,InputMode);
        ADCData := 0;
        for Count := 1 to AverageTimes do
        begin
          RawData := PolledModeReadAD;
          if Signed then RawData := MakeWordSigned(RawData);
          if RawData > RawMax then RawMax := RawData;
          if RawData < RawMin then RawMin := RawData;
          ADCData := ADCData + RawData;
        end;
        ADCData := ADCData div AverageTimes;
        RealData := ADCData * Scale;
        RealPP := (RawMax - RawMin)*Scale;
{        if signed then
        begin
          if  ADCData > 32767 then ADCData := ADCData -65536;
        end; }
        case InputMode of
          InModeNormal: Istring :=  '(Normal) ';
          InModeReverse: Istring := '(Reverse)';
          InModeRef: Istring :=     '(Reference)';
          InModeGnd: Istring :=     '(Ground)';
        end; {case}
        writeln(Istring,' Channel ',Channel,' Data ',ADCData:5,'  ',RealData:1:5,'  PP AC ',RealPP:1:5,'    ');
      end; { for channel }
      writeln;
    end; { for inmode }
  end; { while not(KeyPressed) }
  halt(1);
end.